package com.jiuqi.util.crypto;

import javax.crypto.IllegalBlockSizeException;
import javax.crypto.BadPaddingException;
import java.security.InvalidKeyException;
import javax.crypto.NoSuchPaddingException;
import java.security.Key;
import javax.crypto.Cipher;
import java.security.spec.KeySpec;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import com.jiuqi.util.JqLib;
import java.security.NoSuchAlgorithmException;
import javax.crypto.KeyGenerator;
import java.security.Security;
import java.security.Provider;
import javax.crypto.SecretKey;

public class DESUtil
{
    private static final String Algorithm = "DES";
    
    public static final SecretKey generateKey() {
        try {
            final Class jceClass = Class.forName("com.sun.crypto.provider.SunJCE");
            Security.addProvider(jceClass.newInstance());
            final KeyGenerator keygen = KeyGenerator.getInstance("DES");
            return keygen.generateKey();
        }
        catch (final NoSuchAlgorithmException ex) {
            ex.printStackTrace();
            return null;
        }
        catch (final Exception ex2) {
            ex2.printStackTrace();
            return null;
        }
    }
    
    public static final SecretKey transKey(final String keyHexStr) {
        try {
            final DESKeySpec dks = new DESKeySpec(JqLib.hexStringToBytes(keyHexStr));
            final SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
            final SecretKey key = keyFactory.generateSecret(dks);
            return key;
        }
        catch (final Exception ex) {
            ex.printStackTrace();
            return null;
        }
    }
    
    public static final byte[] encrypt(final SecretKey deskey, final byte[] buff) {
        byte[] cipherByte = null;
        try {
            final Cipher c = Cipher.getInstance("DES");
            c.init(1, deskey);
            cipherByte = c.doFinal(buff);
        }
        catch (final NoSuchPaddingException ex) {
            ex.printStackTrace();
        }
        catch (final NoSuchAlgorithmException ex2) {
            ex2.printStackTrace();
            return null;
        }
        catch (final InvalidKeyException ex3) {
            ex3.printStackTrace();
        }
        catch (final BadPaddingException ex4) {
            ex4.printStackTrace();
        }
        catch (final IllegalBlockSizeException ex5) {
            ex5.printStackTrace();
        }
        return cipherByte;
    }
    
    public static final String decrypt(final SecretKey deskey, final byte[] buff) {
        byte[] cipherByte = null;
        try {
            final Cipher c = Cipher.getInstance("DES");
            c.init(2, deskey);
            cipherByte = c.doFinal(buff);
        }
        catch (final NoSuchPaddingException ex) {
            ex.printStackTrace();
        }
        catch (final NoSuchAlgorithmException ex2) {
            ex2.printStackTrace();
        }
        catch (final InvalidKeyException ex3) {
            ex3.printStackTrace();
        }
        catch (final BadPaddingException ex4) {
            ex4.printStackTrace();
        }
        catch (final IllegalBlockSizeException ex5) {
            ex5.printStackTrace();
        }
        return new String(cipherByte);
    }
}
